/* 
 * DocumentHeader.h
 * Document storage and retrieval header file
 * Synopsis:  This header file is used by Performance to allow for the storage and retrieval of
 *            documents.
 * Created: 1/25/93
 * Author: Christopher Traynor
 */

typedef struct saveinfo
{
  char PartName[30] ;
  char Path[500] ;
  NXRect oldLocation ;
  NXSize imageSize ;
  NXPoint lastLoc ;
  int CurrentFrame ;
  NXCoord DestX ;
  NXCoord DestY ;
  NXCoord StepX ;
  NXCoord StepY ;
  NXPoint StrollPoint ;
  double dFlippingInterval ;
  BOOL bStrolling ;
  BOOL bStrollingContinuous ;
  BOOL bBouncing ;
  BOOL bFlippingInPlace ;
  BOOL bShouldFlip ;
  BOOL bCanFlip ;
  int  iDirection ;
  int  iCurrentDirection ;
  int  iLowerBound ;
  int  iUpperBound ;
  BOOL bIsRIB ;
  BOOL bAllowDrag ;
  BOOL bAllowDoubleClick ;
  BOOL bInitDone ;
  NXPoint hidePoint ;
  BOOL bIsHidden ;
  char szText[100] ;
  char szFont[50] ;
  int iFontSize ;
  NXPoint textLoc ;
  NXColor textColor ;
  float fRed ;
  float fGreen ;
  float fBlue ;
  float fAlpha ;
  BOOL bHasText ;
  BOOL bTextEnabled ;
  char szAlias[30] ;
  char szActorName[40] ;
  BOOL bIsCopy ;
  NXSize ScreenSize ;
  /* UnderstudyAgent elements */
  char szIconName[100][400] ;
  int iIconCount ;
  BOOL bHasIcon ;
  BOOL bDropEnabled ;
  BOOL bShouldDisplayIcon ;
  BOOL bShouldLaunchFile ;
  BOOL bStrollingSuspended ;
  BOOL bFlippingSuspended ;
  NXPoint iconPosition ;
  double dStrollInterval ;
  BOOL bFlipAlways ;
  int iFrameDelay ;
} SAVEINFO ;

typedef SAVEINFO *P_SAVEINFO ;

#define SAVEENCODED "{[30c][500c]{{ff}{ff}}{ff}{ff}iffff{ff}dcccccciiiicccc{ff}c[100c][50c]i{ff}{[6S]*}ffffcc[30c][40c]c{ff}[100[400c]]icccccc{ff}dci}"

