
#import <appkit/appkit.h>
#import "Understudy.h"
#import "DocumentInfo.h"
#import <sys/time.h>

@interface UnderstudyAgent:Understudy
{
    id	iconImage ;
    id  oldIconImage ;
    id  MotionIntervalField ;
    id  StrollXField ;
    id  StrollYField ;
    id	XField;
    id	YField;
    id  XScroller;
    id  YScroller;
    int iX ;
    int iY ;
    char *szIconName[400] ;
    int iIconCount ;
    BOOL bIsVisible ;
    BOOL bTextDisplay ;
    BOOL bHasIcon ;
    BOOL bDropEnabled ;
    BOOL bShouldDisplayIcon ;
    BOOL bShouldLaunchFile ;
    BOOL bStrollingSuspended ;
    BOOL bFlippingSuspended ;
    NXPoint iconPosition ;
    double dStrollInterval ;
}
/* subclassed methods */
- initFromGraphic:(const STR)szFile at:(NXPoint *)theLocation in:(id)theWindow ;
- drawSelf:(const NXRect *)rects :(int)rectCount ;
- mouseDown:(NXEvent *)theEvent ;
- strollTo:(NXCoord)x :(NXCoord)y interval:(double)dInterval 
	   steps:(int)iSteps ;
- strollBy:(NXCoord)x :(NXCoord)y interval:(double)dInterval ;
- strollBounce:(NXCoord)x :(NXCoord)y interval:(double)dInterval ; 
- stopStroll:sender ;

/* dropping methods */

- setDropEnabled:(BOOL)bFlag ;
- (BOOL)dropEnabled ;
- setShouldDisplayIcon:(BOOL)bFlag ;
- (BOOL)shouldDisplayIcon ;
- setShouldLaunchFile:(BOOL)bFlag ;
- (BOOL)shouldLaunchFile ;
- clearIcon ;
- (const char **)droppedFiles ;
- setAttachments:(const char **)theFiles ;
- droppedIcon ;

/* Document Methods */
- saveTo:(P_SAVEINFO)theInfo ;
- loadFrom:(P_SAVEINFO)theInfo ;
- finishLoad ;

/* dragging methods */
- registerForDragging;
- (NXDragOperation)draggingEntered:(id <NXDraggingInfo>)sender;
- (NXDragOperation)draggingUpdated:(id <NXDraggingInfo>)sender;
- draggingExited:(id <NXDraggingInfo>)sender ;
- (BOOL)performDragOperation:(id <NXDraggingInfo>)sender;

/* Agent specific methods */

- setIconLocation:(NXPoint *)thePosition ;

/* methods implemented by the delegate */
- dropOccurred:sender ;
- clearOccurred:sender ;
- launchOccurred:sender ;

@end

/* pasteboard type declarations */
extern NXAtom OHI_UnderstudyPboardType ;
extern char *OHI_UnderstudyPasteboardType ;

@interface UnderstudyAgent(pasteboardMethods)
- copy:sender ;
- cut:sender ;
- delete:sender ;
- paste:sender ;
- setupPasteboard ;
@end

@interface UnderstudyAgent(PasteboardDelegateMethods)

- cutRequestMade:sender ;
- deleteRequestMade:sender ;
- pasteRequestMade:sender for:(SAVEINFO *)theInfo ;

@end

@interface UnderstudyAgent(InspectorMethods)

 /* Attributes Methods */
- (const char *)getUnderstudyPartName ;
- setUnderstudyPartName:(const char *)theName ;
- (BOOL)getUnderstudyVisibility ;
- toggleUnderstudyVisibility ;
- getUnderstudyDragEnable ;
- setUnderstudyDragEnable ;
 /* Animation Methods */

 /* Attatchments */
- getUnderstudyIconXField ;
- setUnderstudyIconXField ;
- getUnderstudyIconYField ;
- setUnderstudyIconYField ;
- getUnderstudyIconImage ;
- setUnderstudyIconImage ;
- (BOOL)getUnderstudyLaunchEnable ;
- setUnderstudyLaunchEnable ;
- (BOOL)getUnderstudyDropEnable ;
- setUnderstudyDropEnable ;
- (BOOL)getUnderstudyIconDisplayEnable ;
- setUnderstudyIconDisplayEnable ;
 /* Text */
- getUnderstudyTextDisplayEnable ;
- setUnderstudyTextDisplayEnable ;
- getUnderstudyTextSourcePartName ;
- setUnderstudyTextSourcePartName ;
- getUnderstudyTextSourceAttatchment ;
- setUnderstudyTextSourceAttatchment ;
- getUnderstudyTextSourceScript ;
- setUnderstudyTextSourceScript ;
- getUnderstudyTextSourceAssigned ;
- setUnderstudyTextSourceAssigned ;
- getUnderstudyTextColor ;
- setUnderstudyTextColor ;
- getUnderstudyAssignedText ;
- setUnderstudyAssignedText ;
 /* Actions */
- getUnderstudyActionTypeNone ;
- setUnderstudyActionTypeNone ;
- getUnderstudyActionTypeFromScript ;
- setUnderstudyActionTypeFromScript ;
- getUnderstudyActionTypeFromBrowser ;
- setUnderstudyActionTypeFromBrowser ;
 /* Miscellaneous */
- getUnderstudySound ;
- setUnderstudySound ;
- getUnderstudySoundPlayOff ;
- setUnderstudySoundPlayOff ;
- getUnderstudySoundPlayOnBounce ;
- setUnderstudySoundPlayOnBounce ;
- getUnderstudySoundPlayWhenSelected ;
- setUnderstudySoundPlayWhenSelected ;
- getUnderstudySoundPlayWhenVisible ;
- setUnderstudySoundPlayWhenVisible ;
- getUnderstudySoundPlayFromScript ;
- setUnderstudySoundPlayFromScript ;

@end
