
#import <appkit/appkit.h>
#import <3Dkit/3Dkit.h>
#import <3Dkit/next3d.h>

#define DIR_FORWARD 1
#define DIR_REVERSE 2
#define DIR_BOUNCE  3

#define STROLL_NONE 0
#define STROLL_TO 1
#define STROLL_BY 2
#define STROLL_BOUNCE 3

/* ZZZ remove the outlets for the support windows */
@interface Understudy:View
{
 id delegate ;
 NXRect oldLocation ;
 NXSize imageSize ;
 NXPoint lastLoc ;
 id idNXImage ;
 id idFrameList ;
 int iFrames ;
 int CurrentFrame ;
 NXCoord DestX ;
 NXCoord DestY ;
 NXCoord StepX ;
 NXCoord StepY ;
 NXPoint StrollPoint ;
 double dFlippingInterval ;
 DPSTimedEntry StrollEntry ;
 DPSTimedEntry FlipEntry ;
 BOOL bStrolling ;
 BOOL bStrollingContinuous ;
 BOOL bBouncing ;
 BOOL bFlippingInPlace ;
 BOOL bShouldFlip ;
 BOOL bCanFlip ;
 int  iDirection ;
 int  iCurrentDirection ;
 int  iLowerBound ;
 int  iUpperBound ;
 BOOL bIsRIB ;
 BOOL bAllowDrag ;
 BOOL bAllowDoubleClick ;
 BOOL bInitDone ;
 NXPoint hidePoint ;
 BOOL bIsHidden ;
 char szText[100] ;
 char szFont[50] ;
 int iFontSize ;
 NXPoint textLoc ;
 NXColor textColor ;
 float fRed ;
 float fGreen ;
 float fBlue ;
 float fAlpha ;
 BOOL bHasText ;
 BOOL bTextEnabled ;
 char szAlias[30] ;
 char szActorName[40] ;
 BOOL bIsCopy ;
 NXSize ScreenSize ;
 int viewLevel ;
 /* performance specific instance elements */
 BOOL bFlipAlways ;
 int iFrameDelay ;
 BOOL bDragRegardless ;
}

- initFromGraphic:(const STR)szFile at:(NXPoint *)theLocation in:(id)theWindow ;
- setDelegate:anObject ;
- delegate ;
- drawSelf:(const NXRect *)rects :(int)rectCount ;
- hide:sender ;
- unhide:sender ;
- moveTo:(NXCoord)x :(NXCoord)y;
- setStepX:(int)step ;
- setStepY:(int)step ;
- (int)stepX ;
- (int)stepY ;
- strollTo:(NXCoord)x :(NXCoord)y interval:(double)dInterval 
	   steps:(int)iSteps ;
- strollBy:(NXCoord)x :(NXCoord)y interval:(double)dInterval ;
- strollBounce:(NXCoord)x :(NXCoord)y interval:(double)dInterval ;
- strollOnce ;
- stopStroll:sender ;
- (int)strollMode ;
- screenSizeChanged ;
- setFrame:(int)iFrame ;
- (int)currentFrame ;
- nextFrame:sender ;
- flipWhileStrolling:sender ;
- stopFlipWhileStrolling:sender ;
- (BOOL)shouldFlipWhileStrolling ;
- setFlipInterval:(double)dInterval ;
- stopFlipping:sender ;
- FlipInPlace:sender ;
- doFlipInPlace ;
- (BOOL)flippingInPlace ;
- (int)xLoc ;
- (int)yLoc ;
- setFlipBounds:(int)iLower :(int)iUpper ;
- setUpperBound:(int)iUpper ;
- setLowerBound:(int)iLower ;
- (int)lowerBound ;
- (int)upperBound ;
- setDirection:(int)iTheDirection ;
- (int)direction ;
- (int)numFrames ;
- mouseUp:(NXEvent *)theEvent ;
- mouseDown:(NXEvent *)theEvent ;
- viewUnderPoint:(NXPoint *)thePoint ;
- (BOOL)isRIB ;
- (N3DHider)RIBhider ;
- setRIBHider:(N3DHider)aHider ;
- setRIBSurfaceType:(N3DSurfaceType)surfaceType ;
- (N3DSurfaceType)RIBsurfaceType ;
- setAllowsDrag:(BOOL)bFlag ;
- (BOOL)allowsDrag ;
- setAllowsDoubleClick:(BOOL)bFlag ;
- (BOOL)allowsDoubleClick ;
- setText:(char *)theText font:(char *)theFont size:(int)theSize 
	  at:(NXPoint *)theLocation color:(NXColor)theColor;
- setTextEnabled:(BOOL)bFlag ;
- (BOOL)textEnabled ;
- setAlias:(char *)theAlias ;
- (const char *)alias ;
- (const char *)name ;
- (NXSize *)getSize ;
- (NXPoint *)getTextLocation ;
- (const char *)currentText ;
- setLevel:(int)level ;
- (int)maxLevel ;
- (int)level ;
- (NXSize *)screenSize ;
- free ;
- updateDisplay ;
- (BOOL)acceptsFirstResponder ;
- (BOOL)acceptsFirstMouse ;

/* activation control methods */
- (BOOL)shouldDelayWindowOrderingForEvent:(NXEvent *)anEvent ;

/* Performance specfic methods */
- setShouldFlipAlways:(BOOL)flag  ;
- (BOOL)shouldFlipAlways ;
- setFrameDelay:(int)theDelay ;
- (int)frameDelay ;

/* methods implemented by the delegate */
- clickOccurred:sender ;
- doubleClickOccurred:sender ;
- dragOccurred:sender ;
- didStroll:sender ;

@end

void doStroll(DPSTimedEntry te, double now, void *userData) ;
void doFlipInPlace(DPSTimedEntry te, double now, void *userData) ;
